//
//  DLib: A simple image processing library.
//
//  David Crandall, 2003-2005
//  crandall@cs.cornell.edu
//
//  Please do not redistribute this code.
//
//
//
//
#ifndef __DIMAGEIO_H_
#define __DIMAGEIO_H_

#include "DImage.h"

DImage ReadPPMImage(const char *filename);
DImage ReadPBMImage(const char *filename);
void WritePPMImage(const _DImage<unsigned char> &img, const char *filename);
void WritePPMImage(const _DPlane<unsigned char> &img, const char *filename);


_DImage<unsigned char> LoadDImage(const char *filename, bool need_alpha = false);
_DImage<unsigned char> LoadDImage(const void *buffer, int buf_size, bool want_alpha = false);
void SaveDImage(const char *filename, const _DImage<unsigned char> &img);
void SaveDImage(const char *filename, const _DPlane<unsigned char> &img);

#endif
