//
//  DLib: A simple image processing library.
//
//  David Crandall, 2003-2005
//  crandall@cs.cornell.edu
//
//  Please do not redistribute this code.
//
//
//
//
#include <DPlane.h>
#include <vector>

class DRegion
{
  public:
    DRegion(DRect &bb, double val) : _bounding_box(bb), pix_value(val) {}
    DRegion() 
    { 
      count = 0; 
      _bounding_box = DRect(1000000,1000000,-1,-1);
    }

    DPoint centroid() { return _centroid; }

    DRect bounding_box() { return _bounding_box; } 
    double pixel_value() { return pix_value; }
    bool is_valid() { return true; }

    DRect _bounding_box;
    double pix_value;
    int count;
    DPoint _centroid;
};

template<class T>
class DLabelComponents
{
  public:
  DLabelComponents() {}

  DLabelComponents(const _DPlane<T> &in_image)
    {
      label_connected_components(in_image);
    }

  void label_connected_components(const _DPlane<T> &in);
  int size() { return region_count; }
  
  DRegion &operator[](int index) { return(regions[index]); }
  
  _DPlane<int> label_plane() { return _label_plane; }
  
 protected:

  int equiv_find(int *equiv,int i)
    {
      int j;
      for(j=i;equiv[j];j=equiv[j]) ;
      int result=j;
      int oldequivj;
      for(j=i;equiv[j];j=oldequivj)
	{
	  oldequivj=equiv[j];
	  equiv[j]=result;
	}
      return(j);
    }
  
  void equiv_union(int *equiv,int a, int b)
    {
      if(equiv_find(equiv,a)!=equiv_find(equiv,b))
	{
	  equiv[equiv_find(equiv,a)]=equiv_find(equiv,b);
	}
    }

  int region_count;
  std::vector<DRegion> regions;    
  _DPlane<int> _label_plane; 
};
