#ifndef __DPROFILE_H_
#define __DPROFILE_H_

#include <vector>
#include <stdio.h>
#include <sys/time.h>

// a very simple code profiling class.
//

class DProfile
{
 public:
  DProfile(int profiler_count)
    {
      call_count = std::vector<long long>(profiler_count, 0);
      timer_offsets = std::vector<long long>(profiler_count, 0);
      elapsed_time = std::vector<long long>(profiler_count, 0);
    }

  DProfile() {}

  ~DProfile() { print_all(); }

  void begin(int i)
    {
      struct timeval tv;
      
      gettimeofday(&tv, 0);
      
     timer_offsets[i] = ((long long)tv.tv_sec)*1000000 + tv.tv_usec;
      call_count[i] ++;
    }

  void end(int i)
    {
      struct timeval tv;
      
      gettimeofday(&tv, 0);
      
      elapsed_time[i] +=  (((long long)tv.tv_sec)*1000000 + tv.tv_usec - timer_offsets[i]);
    }

  int get_call_count(int i)
    {
      return (int) call_count[i];
    }

  int get_elapsed_time(int i)
    {
      return (int) elapsed_time[i];
    }

  void print_all()
    {
      for(int i=0; i<(int) call_count.size(); i++)
	{
	  printf("%15d %15lld %15lld\n", i, call_count[i], elapsed_time[i]);
	}
    }

 protected:
  std::vector<long long> call_count;
  std::vector<long long> timer_offsets, elapsed_time;
};



#endif



