//
//  DLib: A simple image processing library.
//
//  David Crandall, 2003-2005
//  crandall@cs.cornell.edu
//
//  Please do not redistribute this code.
//
//
//
//
template<class T>
class _DTriple
{
    public:
        _DTriple(T _r, T _g, T _b) : r(_r), g(_g), b(_b) {}
        _DTriple() {}

        void operator+=(const _DTriple<T> &other)
        {
            r+=other.r, g+=other.g, b+=other.b;
        }

        void operator/=(const double &d)
        {
            r/=d, g/=d, b/=d;
        }

	T first() const { return r; }
	T second() const { return g; }
	T third() const { return b; }

        T r, g, b;

	template<class T2>
	  friend _DTriple<T2> min(const _DTriple<T2> &t1, const _DTriple<T2> &t2)
	  {
	    return _DTriple<T2>(min(t1.first(), t2.first()), min(t1.second(), t2.second()), min(t1.third(), t2.third()));
	  }

	template<class T2>
	  friend _DTriple<T2> max(const _DTriple<T2> &t1, const _DTriple<T2> &t2)
	  {
	    return _DTriple<T2>(max(t1.first(), t2.first()), max(t1.second(), t2.second()), max(t1.third(), t2.third()));
	  }

	bool operator==(const _DTriple<T> &t) const
	  {
	    return first() == t.first() && second() == t.second() && third() == t.third();
	  }

};

typedef _DTriple<double> DTriple;

